- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | List of all members
AbcPrimalColumnSteepest Class Reference

Primal Column Pivot Steepest Edge Algorithm Class. More...

`#include <AbcPrimalColumnSteepest.hpp>`

Inheritance diagram for AbcPrimalColumnSteepest:
[legend]
Collaboration diagram for AbcPrimalColumnSteepest:
[legend]

## Public Types
enum | Persistence { normal = 0x00, keep = 0x01 }
| enums for persistence More...

## Public Member Functions
Algorithmic methods
virtual int | pivotColumn (CoinPartitionedVector *updates, CoinPartitionedVector *spareRow2, CoinPartitionedVector *spareColumn1)
| Returns pivot column, -1 if none. More...
void | justDjs (CoinIndexedVector *updates, CoinIndexedVector *spareColumn1)
| Just update djs. More...
int | partialPricing (CoinIndexedVector *updates, int numberWanted, int numberLook)
| Update djs doing partial pricing (dantzig) More...
void | djsAndDevex (CoinIndexedVector *updates, CoinIndexedVector *spareRow2, CoinIndexedVector *spareColumn1)
| Update djs, weights for Devex using djs. More...
void | djsAndDevex2 (CoinIndexedVector *updates, CoinIndexedVector *spareColumn1)
| Update djs, weights for Devex using pivot row. More...
void | justDevex (CoinIndexedVector *updates, CoinIndexedVector *spareColumn1)
| Update weights for Devex. More...
int | doSteepestWork (CoinPartitionedVector *updates, CoinPartitionedVector *spareRow2, CoinPartitionedVector *spareColumn1, int type)
| Does steepest work type - 0 - just djs 1 - just steepest 2 - both using scaleFactor 3 - both using extra array. More...
virtual void | updateWeights (CoinIndexedVector *input)
| Updates weights - part 1 - also checks accuracy. More...
void | checkAccuracy (int sequence, double relativeTolerance, CoinIndexedVector *rowArray1)
| Checks accuracy - just for debug. More...
void | initializeWeights ()
| Initialize weights. More...
virtual void | saveWeights (AbcSimplex *model, int mode)
| Save weights - this may initialize weights as well mode is - 1) before factorization 2) after factorization 3) just redo infeasibilities 4) restore weights 5) at end of values pass (so need initialization) More...
virtual void | unrollWeights ()
| Gets rid of last update. More...
virtual void | clearArrays ()
| Gets rid of all arrays. More...
virtual bool | looksOptimal () const
| Returns true if would not find any column. More...
virtual void | maximumPivotsChanged ()
| Called when maximum pivots changes. More...
gets and sets
int | mode () const
| Mode. More...
Constructors and destructors
| AbcPrimalColumnSteepest (int mode=3)
| Default Constructor 0 is exact devex, 1 full steepest, 2 is partial exact devex 3 switches between 0 and 2 depending on factorization 4 starts as partial dantzig/devex but then may switch between 0 and 2. More...
| AbcPrimalColumnSteepest (const AbcPrimalColumnSteepest &rhs)
| Copy constructor. More...
AbcPrimalColumnSteepest & | operator= (const AbcPrimalColumnSteepest &rhs)
| Assignment operator. More...
virtual | ~AbcPrimalColumnSteepest ()
| Destructor. More...
virtual AbcPrimalColumnPivot * | clone (bool copyData=true) const
| Clone. More...
Private functions to deal with devex
bool | reference (int i) const
| reference would be faster using AbcSimplex's status_, but I prefer to keep modularity. More...
void | setReference (int i, bool trueFalse)
| reference would be faster using AbcSimplex's status_, but I prefer to keep modularity. More...
void | setPersistence (Persistence life)
| Set/ get persistence. More...
Persistence | persistence () const
| reference would be faster using AbcSimplex's status_, but I prefer to keep modularity. More...
Public Member Functions inherited from AbcPrimalColumnPivot
virtual int | pivotRow (double &way)
| Signals pivot row choice: -2 (default) - use normal pivot row choice -1 to numberRows-1 - use this (will be checked) way should be -1 to go to lower bound, +1 to upper bound. More...
virtual void | setLooksOptimal (bool flag)
| Sets optimality flag (for advanced use) More...
| AbcPrimalColumnPivot ()
| Default Constructor. More...
| AbcPrimalColumnPivot (const AbcPrimalColumnPivot &)
| Copy constructor. More...
AbcPrimalColumnPivot & | operator= (const AbcPrimalColumnPivot &rhs)
| Assignment operator. More...
virtual | ~AbcPrimalColumnPivot ()
| Destructor. More...
AbcSimplex * | model ()
| Returns model. More...
void | setModel (AbcSimplex *newmodel)
| Sets model. More...
int | type ()
| Returns type (above 63 is extra information) More...
virtual int | numberSprintColumns (int &numberIterations) const
| Returns number of extra columns for sprint algorithm - 0 means off. More...
virtual void | switchOffSprint ()
| Switch off sprint idea. More...

## Private Attributes
Private member data
double | devex_
| weight array More...
double * | weights_
| weight array More...
CoinIndexedVector * | infeasible_
| square of infeasibility array (just for infeasible columns) More...
CoinIndexedVector * | alternateWeights_
| alternate weight array (so we can unroll) More...
double * | savedWeights_
| save weight array (so we can use checkpoint) More...
unsigned int * | reference_
| weight array More...
int | state_
| Status 0) Normal -1) Needs initialization 1) Weights are stored by sequence number. More...
int | mode_
| 0 is exact devex, 1 full steepest, 2 is partial exact devex 3 switches between 0 and 2 depending on factorization 4 starts as partial dantzig/devex but then may switch between 0 and 2. More...
Persistence | persistence_
| Life of weights. More...
int | numberSwitched_
| Number of times switched from partial dantzig to 0/2. More...
int | pivotSequence_
| weight array More...
int | savedPivotSequence_
| weight array More...
int | savedSequenceOut_
| weight array More...
int | lastRectified_
| weight array More...
int | sizeFactorization_
| weight array More...

## Additional Inherited Members
Protected Attributes inherited from AbcPrimalColumnPivot
AbcSimplex * | model_
| Pointer to model. More...
int | type_
| Type of column pivot algorithm. More...
bool | looksOptimal_
| Says if looks optimal (normally computed) More...

## Detailed Description

Primal Column Pivot Steepest Edge Algorithm Class.

See Forrest-Goldfarb paper for algorithm

Definition at line 23 of file AbcPrimalColumnSteepest.hpp.

## Member Enumeration Documentation

enum AbcPrimalColumnSteepest::Persistence

enums for persistence

Enumerator
normal |
keep |

Definition at line 108 of file AbcPrimalColumnSteepest.hpp.

## Constructor & Destructor Documentation

AbcPrimalColumnSteepest::AbcPrimalColumnSteepest | ( | int | mode = `3` | ) |

Default Constructor 0 is exact devex, 1 full steepest, 2 is partial exact devex 3 switches between 0 and 2 depending on factorization 4 starts as partial dantzig/devex but then may switch between 0 and 2.

By partial exact devex is meant that the weights are updated as normal but only part of the nonbasic variables are scanned. This can be faster on very easy problems.

AbcPrimalColumnSteepest::AbcPrimalColumnSteepest | ( | const AbcPrimalColumnSteepest & | rhs | ) |

Copy constructor.

virtual AbcPrimalColumnSteepest::~AbcPrimalColumnSteepest | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

virtual int AbcPrimalColumnSteepest::pivotColumn | ( | CoinPartitionedVector * | updates,
|  | CoinPartitionedVector * | spareRow2,
|  | CoinPartitionedVector * | spareColumn1
| ) |  |
| virtual

Returns pivot column, -1 if none.

The Packed CoinIndexedVector updates has cost updates - for normal LP that is just +-weight where a feasibility changed. It also has reduced cost from last iteration in pivot row Parts of operation split out into separate functions for profiling and speed

Implements AbcPrimalColumnPivot.

void AbcPrimalColumnSteepest::justDjs | ( | CoinIndexedVector * | updates,
|  | CoinIndexedVector * | spareColumn1
| ) |  |

Just update djs.

int AbcPrimalColumnSteepest::partialPricing | ( | CoinIndexedVector * | updates,
|  | int | numberWanted,
|  | int | numberLook
| ) |  |

Update djs doing partial pricing (dantzig)

void AbcPrimalColumnSteepest::djsAndDevex | ( | CoinIndexedVector * | updates,
|  | CoinIndexedVector * | spareRow2,
|  | CoinIndexedVector * | spareColumn1
| ) |  |

Update djs, weights for Devex using djs.

void AbcPrimalColumnSteepest::djsAndDevex2 | ( | CoinIndexedVector * | updates,
|  | CoinIndexedVector * | spareColumn1
| ) |  |

Update djs, weights for Devex using pivot row.

void AbcPrimalColumnSteepest::justDevex | ( | CoinIndexedVector * | updates,
|  | CoinIndexedVector * | spareColumn1
| ) |  |

Update weights for Devex.

int AbcPrimalColumnSteepest::doSteepestWork | ( | CoinPartitionedVector * | updates,
|  | CoinPartitionedVector * | spareRow2,
|  | CoinPartitionedVector * | spareColumn1,
|  | int | type
| ) |  |

Does steepest work type - 0 - just djs 1 - just steepest 2 - both using scaleFactor 3 - both using extra array.

virtual void AbcPrimalColumnSteepest::updateWeights | ( | CoinIndexedVector * | input | ) |
| virtual

Updates weights - part 1 - also checks accuracy.

Reimplemented from AbcPrimalColumnPivot.

void AbcPrimalColumnSteepest::checkAccuracy | ( | int | sequence,
|  | double | relativeTolerance,
|  | CoinIndexedVector * | rowArray1
| ) |  |

Checks accuracy - just for debug.

void AbcPrimalColumnSteepest::initializeWeights | ( |  | ) |

Initialize weights.

virtual void AbcPrimalColumnSteepest::saveWeights | ( | AbcSimplex * | model,
|  | int | mode
| ) |  |
| virtual

Save weights - this may initialize weights as well mode is - 1) before factorization 2) after factorization 3) just redo infeasibilities 4) restore weights 5) at end of values pass (so need initialization)

Implements AbcPrimalColumnPivot.

virtual void AbcPrimalColumnSteepest::unrollWeights | ( |  | ) |
| virtual

Gets rid of last update.

virtual void AbcPrimalColumnSteepest::clearArrays | ( |  | ) |
| virtual

Gets rid of all arrays.

Reimplemented from AbcPrimalColumnPivot.

virtual bool AbcPrimalColumnSteepest::looksOptimal | ( |  | ) | const
| virtual

Returns true if would not find any column.

Reimplemented from AbcPrimalColumnPivot.

virtual void AbcPrimalColumnSteepest::maximumPivotsChanged | ( |  | ) |
| virtual

Called when maximum pivots changes.

Reimplemented from AbcPrimalColumnPivot.

int AbcPrimalColumnSteepest::mode | ( |  | ) | const
| inline

Mode.

Definition at line 101 of file AbcPrimalColumnSteepest.hpp.

AbcPrimalColumnSteepest& AbcPrimalColumnSteepest::operator= | ( | const AbcPrimalColumnSteepest & | rhs | ) |

Assignment operator.

virtual AbcPrimalColumnPivot* AbcPrimalColumnSteepest::clone | ( | bool | copyData = `true` | ) | const
| virtual

Clone.

Implements AbcPrimalColumnPivot.

bool AbcPrimalColumnSteepest::reference | ( | int | i | ) | const
| inline

reference would be faster using AbcSimplex's status_, but I prefer to keep modularity.

Definition at line 143 of file AbcPrimalColumnSteepest.hpp.

void AbcPrimalColumnSteepest::setReference | ( | int | i,
|  | bool | trueFalse
| ) |  |
| inline

reference would be faster using AbcSimplex's status_, but I prefer to keep modularity.

Definition at line 146 of file AbcPrimalColumnSteepest.hpp.

void AbcPrimalColumnSteepest::setPersistence | ( | Persistence | life | ) |
| inline

Set/ get persistence.

Definition at line 155 of file AbcPrimalColumnSteepest.hpp.

Persistence AbcPrimalColumnSteepest::persistence | ( |  | ) | const
| inline

reference would be faster using AbcSimplex's status_, but I prefer to keep modularity.

Definition at line 158 of file AbcPrimalColumnSteepest.hpp.

## Member Data Documentation

double AbcPrimalColumnSteepest::devex_
| private

weight array

Definition at line 168 of file AbcPrimalColumnSteepest.hpp.

double* AbcPrimalColumnSteepest::weights_
| private

weight array

Definition at line 170 of file AbcPrimalColumnSteepest.hpp.

CoinIndexedVector* AbcPrimalColumnSteepest::infeasible_
| private

square of infeasibility array (just for infeasible columns)

Definition at line 172 of file AbcPrimalColumnSteepest.hpp.

CoinIndexedVector* AbcPrimalColumnSteepest::alternateWeights_
| private

alternate weight array (so we can unroll)

Definition at line 174 of file AbcPrimalColumnSteepest.hpp.

double* AbcPrimalColumnSteepest::savedWeights_
| private

save weight array (so we can use checkpoint)

Definition at line 176 of file AbcPrimalColumnSteepest.hpp.

unsigned int* AbcPrimalColumnSteepest::reference_
| private

weight array

Definition at line 178 of file AbcPrimalColumnSteepest.hpp.

int AbcPrimalColumnSteepest::state_
| private

Status 0) Normal -1) Needs initialization 1) Weights are stored by sequence number.

Definition at line 184 of file AbcPrimalColumnSteepest.hpp.

int AbcPrimalColumnSteepest::mode_
| private

0 is exact devex, 1 full steepest, 2 is partial exact devex 3 switches between 0 and 2 depending on factorization 4 starts as partial dantzig/devex but then may switch between 0 and 2.

5 is always partial dantzig By partial exact devex is meant that the weights are updated as normal but only part of the nonbasic variables are scanned. This can be faster on very easy problems.

New dubious option is >=10 which does mini-sprint

Definition at line 197 of file AbcPrimalColumnSteepest.hpp.

Persistence AbcPrimalColumnSteepest::persistence_
| private

Life of weights.

Definition at line 199 of file AbcPrimalColumnSteepest.hpp.

int AbcPrimalColumnSteepest::numberSwitched_
| private

Number of times switched from partial dantzig to 0/2.

Definition at line 201 of file AbcPrimalColumnSteepest.hpp.

int AbcPrimalColumnSteepest::pivotSequence_
| private

weight array

Definition at line 203 of file AbcPrimalColumnSteepest.hpp.

int AbcPrimalColumnSteepest::savedPivotSequence_
| private

weight array

Definition at line 205 of file AbcPrimalColumnSteepest.hpp.

int AbcPrimalColumnSteepest::savedSequenceOut_
| private

weight array

Definition at line 207 of file AbcPrimalColumnSteepest.hpp.

int AbcPrimalColumnSteepest::lastRectified_
| private

weight array

Definition at line 209 of file AbcPrimalColumnSteepest.hpp.

int AbcPrimalColumnSteepest::sizeFactorization_
| private

weight array

Definition at line 211 of file AbcPrimalColumnSteepest.hpp.

The documentation for this class was generated from the following file:

- /tmp/CHiPPS-Blis-0.94.3/Clp/src/AbcPrimalColumnSteepest.hpp